package com.xyhy.jiaranmqttcluster.common.rabbitmq;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import com.xyhy.jiaranmqttcluster.common.Common;

public class RabbitUtils extends Common {

    private static final ConnectionFactory CONNECTION_FACTORY = new ConnectionFactory();

    static {
        CONNECTION_FACTORY.setHost(Common.getConfigByName("rabbitMq.server.ip"));
        CONNECTION_FACTORY.setPort(Integer.parseInt(Common.getConfigByName("rabbitMq.server.port")));
        CONNECTION_FACTORY.setUsername(Common.getConfigByName("rabbitMq.server.userName"));
        CONNECTION_FACTORY.setPassword(Common.getConfigByName("rabbitMq.server.passWord"));
        CONNECTION_FACTORY.setVirtualHost(Common.getConfigByName("rabbitMq.server.vHost"));
    }

    //获取连接方法
    public static Connection getConnection() {
        try {
            return CONNECTION_FACTORY.newConnection();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    //获取通道
    public static Channel getChannel() {
        try {
            return RabbitUtils.getConnection().createChannel();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    //关闭通道和关闭连接工具方法
    public static void closeConnectionAndChannel(Channel channel, Connection connection) {
        try {
            if (channel != null) {
                channel.close();
            }

            if (connection != null) {
                connection.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
