package com.xyhy.jiaranmqttcluster.common.rabbitmq.listening;

import com.alibaba.fastjson.JSON;
import com.rabbitmq.client.*;
import com.xyhy.jiaranmqttcluster.common.Basic;
import com.xyhy.jiaranmqttcluster.common.Common;
import com.xyhy.jiaranmqttcluster.common.message.back.MessageBackThreadGroupCommon;
import com.xyhy.jiaranmqttcluster.common.message.back.Message_back_thirdPartyPush_jaran;
import com.xyhy.jiaranmqttcluster.common.mqtt.MqttGetMessage;
import com.xyhy.jiaranmqttcluster.common.mqtt.MqttServer;
import com.xyhy.jiaranmqttcluster.common.rabbitmq.RabbitUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;

public class Listen_thirdPartyPush_jiaran {

    public final Logger log =  LoggerFactory.getLogger(this.getClass());

    public void start()
    {

        String exchangeName = Common.getConfigByName("rabbitMq.server.TOMQTTSERVEREXCHANGE");
//        String queueName = "mqtt."+ Common.FUNCTION_ADDORDER_CALLBACK;
        String queueName = Common.getConfigByName("rabbitMq.server.ip")+"."+ Basic.FUNCTION_THIRD_PARTY_PUSH_JIARAN;
        String Topic = queueName;

        try {
            Channel channel =  RabbitUtils.getChannel();
            channel.exchangeDeclare(exchangeName, "topic",true);
            channel.queueDeclare(queueName,true,false,false,null);
            channel.queueBind(queueName,exchangeName,Topic);

            Consumer consumer = new DefaultConsumer(channel) {
                @Override
                public void handleDelivery(String consumerTag, Envelope envelope, AMQP.BasicProperties properties,
                                           byte[] body) throws IOException {

                    String message = new String(body, "UTF-8");
                    log.info(message);
                    MqttServer.getInstance().pushlish(Common.getConfigByName("MQTT.server.Subscribe"), message);
                }
            };
            // channel绑定队列、消费者，autoAck为true表示一旦收到消息则自动回复确认消息
            channel.basicConsume(queueName, true, consumer);
            log.info("第三方推送开始监听.....");
        } catch (IOException e) {
            log.error("第三方推送开始监听",e);
        }
    }

}
